VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00000000&
   Caption         =   "VB Gamma Sample"
   ClientHeight    =   5235
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   6000
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   349
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   400
   StartUpPosition =   3  'Windows Default
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuGoStop 
         Caption         =   "Go/Stop"
      End
      Begin VB.Menu mnuSingleStep 
         Caption         =   "Single Step"
      End
      Begin VB.Menu mnuFileLine1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuChangeDevice 
         Caption         =   "Change Device..."
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuFileLine2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit          ESC"
      End
   End
   Begin VB.Menu mnugammaRamp 
      Caption         =   "&Gamma Ramp"
      Begin VB.Menu mnuTest 
         Caption         =   "Test          T"
      End
      Begin VB.Menu mnuGammaRampLine1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuGray 
         Caption         =   "Gray"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuRed 
         Caption         =   "Red"
      End
      Begin VB.Menu mnuGreen 
         Caption         =   "Green"
      End
      Begin VB.Menu mnuBlue 
         Caption         =   "Blue"
      End
      Begin VB.Menu mnuGammaRampLine2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSingleGamma 
         Caption         =   "Single Gamma"
         Checked         =   -1  'True
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpDisplay 
         Caption         =   "Display"
         Shortcut        =   {F1}
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  Application Title:       VB Gamma Correction Sample
'  Developer:               Eric DeBrosse [MS MVP]
'                           The DirectX Cool Fool!
'                           http://www.blown.com/dx/
'
'  File:        frmMain.frm
'  Content:     A gamma correction sample utilizing the VB DX8.1
'               SDK framework. An adaptation of a sample originally
'               written by Rich Thomson.
'
'
'               Instructions
'               ------------
'
' The program has two main displays: measurement and test.  The program
' starts with the measurement display to characterize the monitor by a
' single gamma.  When you have two displayed areas of equal intensity,
' try testing out your gamma value with the 'T' key.
'
' The test display consists of an upper and lower portion.  The upper
' portion displays bars of constant grayscale intensity at 0%, 25%, 75%,
' and 100% of full intensity.  The bottom portion displays an interpolated
' grayscale ramp.  The ramp should match in intensity the constant bar
' right in the middle of the constant bar, approximately where the text
' is drawn.  You will find that they probably don't match in windowed
' mode, but do match in exclusive mode when your device supports a
' gamma ramp.  This is normal behavior for this situation.  The best
' quality renderings will be obtained when you can use linear math and
' gamma correct at the video scanout stage.
'
' General keyboard commands:
' T        Toggle between test and measurement.
' 1        Toggle between grayscale gamma and RGB gamma.
'
' Measurement keyboard commands:
' Y        measure grayscale gamma
' R        measure red gamma
' G        measure green gamma
' B        measure blue gamma
' Up/Down  increase/decrease gamma by 1 step
' PageUp/  increase/decrease gamma by 5 steps
' PageDown
'
' Standard D3DFrame keyboard commands:
' F2       Change Device
' ESC      Quit
'
' Background
' ----------
' This sample shows how to measure the gamma of the monitor, with a little
' help from the user.  You can measure a single gamma value that you use
' for all three primaries, or you can measure the gamma of each primary
' separately.
'
' The basic idea behind this technique is as follows.  First you draw a
' rectangle with alternating scanlines of white and black.  When viewed
' from a distance, your eye should average these white and black lines
' together and see the area as a shade of gray.  In fact, because this is
' 50% of the total brightness we can draw into a rectangle, it should be
' half the maximum intensity that we can display.
'
' If you draw a rectangle adjacent to these lines with the color
' (128, 128, 128) approximating 50% gray as linear RGB, you'll find that
' two areas don't appear to have the same intensity at all.  The answer
' to this problem comes from the CRT monitor itself.  The brightness of
' the monitor is nonlinear with respect to the input RGB signals.  The
' intensity of a CRT, with input voltage V in [0,1], is characterized as:
'
'             gamma
'      I = c V
'
' The phrase "gamma correction" derives from the use of the greek letter
' gamma in this equation.  This equation lets us compensate for the non-
' linear characteristics of a CRT if we can measure its gamma.  (The 'c'
' above is just a proportionality constant.  In graphics we just need
' the gamma because the CRT monitor is manufactured to deal with the 'c'.)
' You can use a piece of dedicated equipment to measure a CRT's gamma
' accurately and directly.  These are often used in the printing press
' industry to ensure color fidelity, but most people don't have one.
'
' In this sample, we effectively measure the CRT's gamma by using the
' human eyeball as the measuring device!  A little feedback from the user
' is all we need to determine the gamma within the resolution of an 8-bit
' color channel.
'
' For best results, run the sample on an 24 or 32 bit desktop or use a
' full screen mode with 8-bits per channel.  The quantization in 16-bit
' formats when changing the solid area's color give a less accurate
' reading, and it may be impossible for the user to match up the
' corresponding sides as close as they could in an 8-bit per channel
' format.
'
' You may also find that the measured gamma of your device varies
' between windowed mode and exclusive mode.  In windowed mode, the device
' is owned by GDI and GDI controls how and if the device's gamma
' correction hardware is used.  For information about gamma correction
' under GDI look at the Platform SDK documentation on Image Color
' Management (ICM).
'
' A Direct3D application can compensate for a monitor's non-linearity
' by using the D3DGAMMARAMP with the SetGammaRamp method on the device.
' However, this only works in exclusive applications and the device must
' have the D3DCAPS2_FULLSCREENGAMMA capability.  The gamma ramp defines
' the mapping from the linear RGB space in which Direct3D computes colors
' into the device-dependent space described by the gamma equation above.
' The gamma ramp is applied during video scanout and is the very last
' thing applied to the pixels before they are sent to the monitor for
' display in full-screen mode.  (The gamma ramp doesn't apply in windowed
' mode.  GDI gamma correction mechanisms are in force then.)
'
' The gamma value can vary for the different phosphors in a monitor, so
' you may want to measure the gamma for the intensity of the red, green,
' and blue phosphors separately.  In this case you use the separate red,
' green and blue gamma values to compute the red, green and blue arrays
' in the D3DGAMMARAMP structure.
'
' Without device gamma ramp support or in windowed mode, an application
' must manually compensate for device gamma.  The easiest way to achieve
' this is to supply the rendering pipeline with gamma-corrected colors,
' combine them as if they were linear and live with the resulting error.
' You have probably been writing your 3D programs this way, blissfully
' ignorant of the CRT's gamma.  At the same time, if you try your program
' out on multiple monitors you may find out that it looks "darker" on
' some monitors and "brighter" on other monitors.  This is the device's
' non-linear response biting you.
'
' This is not the only approach to manual gamma correction, merely the
' easiest.  Another approach would be to use a pixel shader and gamma
' correct in the shader.  You can probably think of some more ways to
' apply gamma correction for your specific needs.
'
' For a more detailed explanation of gamma and its consequences, please
' read the excellent technical memo on gamma correction by Alvy Ray Smith
' at <http://www.alvyray.com/Memos/MemosMicrosoft.htm>.  See also
' "Dirty Pixels", Jim Blinn, IEEE Computer Graphics & Applications,
' July 1989.
'
' This project includes portions of the Microsoft DirectX 8.1
' SDK. Copyright (c) 1999-2001 Microsoft Corporation. All rights
' reserved. Portions Copyright (C) 2001 Rich Thomson. All rights
' reserved. <http://www.xmission.com/~legalize/> Content is not
' to be duplicated without permission from the authors.
'
' I would like to thank Robert Dunlop at the X-Zone
' <http://www.mvps.org/directx/> for help testing and debugging
' the sample code.
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'-----------------------------------------------------------------------------
' Variables
'-----------------------------------------------------------------------------

Dim m_bIsInit As Boolean                'indicates d3d has been initialized
Dim m_bIsMinimized As Boolean           'indicates display window is minimized
Dim m_bIsRunning As Boolean             'indicates animation is running

'holds width and height of frame buffer
Dim m_lBufWidth As Long
Dim m_lBufHeight As Long
Dim m_DispFormat As CONST_D3DFORMAT

Dim m_oStatusFont As D3DXFont
Dim m_FontRect As RECT
Dim m_sStatusText As String
Dim m_ColorText As Long

Dim m_Top As Long
Dim m_Bottom As Long
Dim m_Left As Long
Dim m_Right As Long
Dim m_Center As Long

'constants for gamma keyboard controls
Const GAMMA_LINE_SIZE = 1      'up, down
Const GAMMA_PAGE_SIZE = 5      'page up, page down
Const HOME_GAMMA = 1           'home
Const END_GAMMA = 254          'end
Const INITIAL_GAMMA = 190      'arbitrary, but close enough for my monitor ;-)

Enum E_EDIT_GAMMA
    G_GRAY = 0
    G_RED = 1
    G_GREEN = 2
    G_BLUE = 3
End Enum

Dim m_Gamma(4) As Long
Dim m_Ramp As D3DGAMMARAMP
Dim m_eWhichGamma As E_EDIT_GAMMA

'custom vertex type for rendering gingerbread man and bounding box
Const VERTEX_FVF = D3DFVF_XYZRHW Or D3DFVF_DIFFUSE

'structure for vertices
Private Type MYVERTEX
    x As Single
    y As Single
    z  As Single
    rhw As Single
    Diffuse As Long
End Type

Dim m_Vertices() As MYVERTEX
Dim m_Solid(6) As MYVERTEX
Dim m_Stripes(22) As MYVERTEX
Dim m_Indices(36) As Integer

'-----------------------------------------------------------------------------
' Name: MakeVertex
' Desc: Returns a filled MYVERTEX structure.
'-----------------------------------------------------------------------------
Private Function MakeVertex(ByVal x As Single, _
                            ByVal y As Single, _
                            ByVal Diffuse As Long) As MYVERTEX
    With MakeVertex
        .x = x
        .y = y
        .z = 0.5!
        .rhw = 2!
        .Diffuse = Diffuse
    End With
End Function

'-----------------------------------------------------------------------------
' Name: GetCurrentDeviceName
' Desc: Returns a string that describes the current D3D device.
'-----------------------------------------------------------------------------
Private Function GetCurrentDeviceName() As String
    Dim sDescription As String
    
    sDescription = StrConv(g_Adapters(g_lCurrentAdapter).d3dai.Description, vbUnicode)
    sDescription = Replace(sDescription, Chr$(0), "")
    
    'do we have a description?
    If sDescription = "" Then
        GetCurrentDeviceName = "Unknown Device"
    Else
        'return device description
        GetCurrentDeviceName = sDescription
    End If
End Function

'-----------------------------------------------------------------------------
' Name: GammaColor()
' Desc: Used for drawing graphic elements that are not part
'       of the testing or measurement.  The text and background
'       colors are in this category. Takes an RGB color with an
'       assumed gamma of 1.0 and returns a color suitable for use
'       in the program's current mode.  Unless we are displaying
'       test graphics in full screen with gamma ramp support,
'       we'll have to gamma correct the color.
'-----------------------------------------------------------------------------
Private Function GammaColor(ByVal Red As Byte, _
                            ByVal Green As Byte, _
                            ByVal Blue As Byte) As Long
    'if possible, device will correct gamma
    GammaColor = D3DCOLORAUX.D3DColorXRGB(Red, Green, Blue)
    
    If g_Adapters(g_lCurrentAdapter).bWindowed = True Or _
                (g_d3dCaps.Caps2 And D3DCAPS2_FULLSCREENGAMMA) <> D3DCAPS2_FULLSCREENGAMMA Or _
                mnuTest.Checked = False Then
        'device doesn't gamma correct, so we have to
        If mnuSingleGamma.Checked = True Then
            Dim recip_gray As Single
            
            recip_gray = RecipGamma(m_Gamma(G_GRAY))
            
            GammaColor = D3DCOLORAUX.D3DColorXRGB(CInt(RampValue(Red, recip_gray, 255)), _
                    CInt(RampValue(Green, recip_gray, 255)), _
                    CInt(RampValue(Blue, recip_gray, 255)))
            
        Else
            Dim recip_red As Single
            Dim recip_green As Single
            Dim recip_blue As Single
            
            recip_red = RecipGamma(m_Gamma(G_RED))
            recip_green = RecipGamma(m_Gamma(G_GREEN))
            recip_blue = RecipGamma(m_Gamma(G_BLUE))
            
            GammaColor = D3DCOLORAUX.D3DColorXRGB(CInt(RampValue(Red, recip_red, 255)), _
                    CInt(RampValue(Green, recip_green, 255)), _
                    CInt(RampValue(Blue, recip_blue, 255)))
        End If
    End If
End Function

'-----------------------------------------------------------------------------
' Name: GammaColorEx()
' Desc: Return a color that is gamma corrected as needed.
'       Used to keep the background and text colors the same
'       intensity regardless of whether or not the gamma ramp
'       is used.
'-----------------------------------------------------------------------------
Public Function GammaColorEx(ByVal lColor As Long) As Long
    Dim r As Long
    Dim g As Long
    Dim b As Long
    
    r = (lColor And &HFF0000) / (2 ^ 16)
    g = (lColor And &HFF00&) / (2 ^ 8)
    b = (lColor And &HFF&)
    
    GammaColorEx = GammaColor(r, g, b)
End Function

'-----------------------------------------------------------------------------
' Name: RampValue()
' Desc: The gamma function with inputs in [0,255], scaled to
'       a range with the default range appropriate for
'       D3DGAMMARAMP.
'-----------------------------------------------------------------------------
Private Function RampValue(ByVal i As Byte, _
                           ByVal lRecipGamma As Single, _
                           Optional ByVal lScale As Long = 65535) As Long
    RampValue = lScale * ((i / 255!) ^ lRecipGamma)
End Function

'-----------------------------------------------------------------------------
' Name: RecipGamma()
' Desc: Given a gamma corrected i in [0,255], return 1/gamma.
'-----------------------------------------------------------------------------
Private Function RecipGamma(ByVal i As Byte) As Single
    RecipGamma = Log(i / 255!) / Log(0.5)
End Function

'-----------------------------------------------------------------------------
' Name: Gamma()
' Desc: Given a gamma corrected color channel value in [0,255],
'       return the gamma.
'-----------------------------------------------------------------------------
Private Function Gamma(ByVal i As Byte) As Single
    Gamma = Log(0.5) / Log(i / 255!)
End Function

'-----------------------------------------------------------------------------
' Name: LongToInt()
' Desc: Converts a Long value to a signed Integer.
'-----------------------------------------------------------------------------
Private Function LongToInt(ByVal ValueIn As Long) As Integer
    Dim HoldValue As Long
    Dim ui As Long
    
    HoldValue = ValueIn
    ui = 0
    If HoldValue > 32767 Then ui = 1: HoldValue = HoldValue - 32767
    If HoldValue > 32767 Then HoldValue = 32767
    
    LongToInt = HoldValue Or (&H8000 * ui)
End Function

'-----------------------------------------------------------------------------
' Name: Form_Load()
' Desc: Application starting point and main processing loop.
'-----------------------------------------------------------------------------
Private Sub Form_Load()
    On Error Resume Next
    
    'set defaults
    m_ColorText = &HFFCACA00    'gamma=1.0
    
    m_Gamma(G_GRAY) = INITIAL_GAMMA
    m_Gamma(G_RED) = INITIAL_GAMMA
    m_Gamma(G_GREEN) = INITIAL_GAMMA
    m_Gamma(G_BLUE) = INITIAL_GAMMA
    m_eWhichGamma = G_GRAY
    
    'force form to show now
    Me.Show
    DoEvents
    
    'Initialize D3D
    'Note: D3DUtil_Init will attempt to use D3D Hardware acceleration.
    'If not available, it will attempt to use the Software Reference Rasterizer.
    'If everything fails, it will display a message box indicating so.
    m_bIsInit = D3DUtil_Init(Me.hwnd, True, 0, 0, D3DDEVTYPE_HAL, Me)
    If Not (m_bIsInit) Then End
    
    'sets the state for the objects and the current D3D device
    InitDeviceObjects
    RestoreDeviceObjects
    
    'run the simulation forever
    'see Form_Keydown for exit processing
    Do While True
        'increment the simulation
        FrameMove
        
        'render one frame of the simulation
        If Render() = True Then
            'present the image to the screen
            g_dev.Present ByVal 0&, ByVal 0&, g_focushwnd, ByVal 0&
        End If
        
        'allow for events to get processed
        DoEvents
    Loop
End Sub

'-----------------------------------------------------------------------------
' Name: Form_KeyDown()
' Desc: Process key messages for exit and change device
'-----------------------------------------------------------------------------
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim hr As Long
    
    Select Case KeyCode
        Case vbKeyEscape
            'escape to exit
            Unload Me
            
        Case vbKeyF2
            'Pause the timer
            DXUtil_Timer TIMER_STOP
            
            'Bring up the device selection dialog
            'we pass in the form so the selection process
            'can make calls into InitDeviceObjects
            'and RestoreDeviceObjects
            frmSelectDevice.SelectDevice Me
            
            'Restart the timer
            DXUtil_Timer TIMER_start
            
        Case vbKeyReturn
            'Check for Alt-Enter, if not pressed exit
            If Shift <> 4 Then Exit Sub
            
            'we must invalidate objects before a reset
            InvalidateDeviceObjects
            
            'If we are windowed go fullscreen
            'If we are fullscreen returned to windowed
            If g_d3dpp.Windowed Then
                 hr = D3DUtil_ResetFullscreen
            Else
                 hr = D3DUtil_ResetWindowed
            End If
                             
            'Call Restore after every mode change
            'because calling reset looses states that need to
            'be reinitialized
            If hr = D3D_OK Then
                RestoreDeviceObjects
            End If
            
        Case vbKeyH
            mnuHelpDisplay_Click
            
        Case vbKeyT
            mnuTest_Click
            
        Case vbKey1
            mnuSingleGamma_Click
            
        Case vbKeyY
            mnuGray_Click
            
        Case vbKeyR
            mnuRed_Click
            
        Case vbKeyG
            mnuGreen_Click
            
        Case vbKeyB
            mnuBlue_Click
            
        Case vbKeyPageUp
            If mnuTest.Checked = False Then
                IncGamma GAMMA_PAGE_SIZE
            End If
        Case vbKeyPageDown
            If mnuTest.Checked = False Then
                IncGamma -GAMMA_PAGE_SIZE
            End If
        Case vbKeyUp
            If mnuTest.Checked = False Then
                IncGamma GAMMA_LINE_SIZE
            End If
        Case vbKeyDown
            If mnuTest.Checked = False Then
                IncGamma -GAMMA_LINE_SIZE
            End If
        Case vbKeyHome
            If mnuTest.Checked = False Then
                m_Gamma(m_eWhichGamma) = HOME_GAMMA
                IncGamma 0
            End If
        Case vbKeyEnd
            If mnuTest.Checked = False Then
                m_Gamma(m_eWhichGamma) = END_GAMMA
                IncGamma 0
            End If
    End Select
End Sub

'-----------------------------------------------------------------------------
' Name: Form_Resize()
' Desc: Handles resizing of the D3D backbuffer.
'-----------------------------------------------------------------------------
Private Sub Form_Resize()
    'If D3D is not initialized then exit
    If Not m_bIsInit Then Exit Sub
    
    'If we are in a minimized state stop the timer and exit
    If Me.WindowState = vbMinimized Then
        DXUtil_Timer TIMER_STOP
        m_bIsMinimized = True
        Exit Sub
        
    'If we just went from a minimized state to maximized
    'restart the timer
    Else
        If m_bIsMinimized = True Then
            If m_bIsRunning = True Then
                DXUtil_Timer TIMER_start
            End If
            m_bIsMinimized = False
        End If
    End If
    
    'dont let the window get too small
    If Me.ScaleWidth < 10 Then
        Me.width = Screen.TwipsPerPixelX * 10
        Exit Sub
    End If
    
    If Me.ScaleHeight < 10 Then
        Me.height = Screen.TwipsPerPixelY * 10
        Exit Sub
    End If
    
    'fonts must be destroyed before a reset
    InvalidateDeviceObjects
    
    'reset and resize our D3D backbuffer to the size of the window
    D3DUtil_ResizeWindowed Me.hwnd
    
    'All states get lost after a reset, so we need to re-initialize
    RestoreDeviceObjects
End Sub

'-----------------------------------------------------------------------------
' Name: Form_Unload()
' Desc: Destroys all objects that were in use by application.
'-----------------------------------------------------------------------------
Private Sub Form_Unload(Cancel As Integer)
    'destroy all objects
    InvalidateDeviceObjects
    DeleteDeviceObjects
    
    'destroy d3d stuff
    D3DUtil_Destory
    
    'end program
    End
End Sub

'-----------------------------------------------------------------------------
' Name: SetStates()
' Desc: Set the renderstates appropriate for the app.
'-----------------------------------------------------------------------------
Private Sub SetStates()
    On Error Resume Next
    
    'set initial device states
    With g_dev
        .SetRenderState D3DRS_COLORVERTEX, 1
        .SetRenderState D3DRS_LIGHTING, 0
        .SetRenderState D3DRS_ALPHATESTENABLE, 0
        .SetRenderState D3DRS_ZENABLE, D3DZB_FALSE
        .SetRenderState D3DRS_STENCILENABLE, 0
        .SetRenderState D3DRS_ALPHABLENDENABLE, 0
        .SetRenderState D3DRS_SHADEMODE, D3DSHADE_GOURAUD
        .SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID
        .SetRenderState D3DRS_DITHERENABLE, 1
        .SetRenderState D3DRS_LASTPIXEL, 1
    End With
End Sub

'-----------------------------------------------------------------------------
' Name: CreateFonts()
' Desc: Create the D3DXFont for the status text.
'-----------------------------------------------------------------------------
Private Sub CreateFonts()
    Dim oTempFont As IFont
    
    'create status font
    Set oTempFont = frmMain.Font
    Set m_oStatusFont = Nothing
    Set m_oStatusFont = g_d3dx.CreateFont(g_dev, oTempFont.hFont)
    Set oTempFont = Nothing
End Sub

'-----------------------------------------------------------------------------
' Name: FrameMove()
' Desc: Called once per frame, the call is the entry point for animating
'       the scene.
'-----------------------------------------------------------------------------
Private Sub FrameMove()
    '
End Sub

'-----------------------------------------------------------------------------
' Name: Render()
' Desc: Called once per frame, the call is the entry point for 3d
'       rendering. This function sets up render states, clears the
'       viewport, and renders the scene.
'-----------------------------------------------------------------------------
Private Function Render() As Boolean
    On Error Resume Next
    
    If g_dev Is Nothing Then GoTo errOut
    
    Select Case g_dev.TestCooperativeLevel
        Case D3DERR_DEVICENOTRESET
            'try to reset device
            g_dev.Reset g_d3dpp
            Exit Function
            
        Case Is <> D3D_OK
            'dont bother rendering if we are not ready yet
            Exit Function
    End Select
    
    On Error GoTo errOut
    
    'begin scene
    g_dev.BeginScene
    
    'clear the back buffer to dark slate gray.  (Rich got this color name
    'and value from the rgb.txt file in the X11 Window System distribution
    '<ftp://ftp.x.org/pub/R6.5.1/xc/programs/rgb/rgb.txt>.  The colors in
    'that file should all be assumed to have a gamma of 2.22.)
    '
    'Gamma correct the background color as needed.
    Dim dark_slate_gray As Long
    dark_slate_gray = GammaColor(6, 19, 19)
    g_dev.Clear 0&, ByVal 0&, D3DCLEAR_TARGET, dark_slate_gray, 1!, 0&
    
    'either show help or display gamma correction graphics
    If mnuHelpDisplay.Checked = True Then
        'show help text
        m_oStatusFont.Begin
        
        m_sStatusText = "Keyboard Commands:" & vbCrLf & "F1" & vbCrLf & "T" & vbCrLf & "1" & _
                vbCrLf & "Y" & vbCrLf & "R,G,B"
        
        m_FontRect.Left = 20
        m_FontRect.Top = 20
        m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
        m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
        
        m_sStatusText = "See frmMain.frm for details."
        
        m_FontRect.Top = m_lBufHeight - 100
        m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
        m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
        
        m_sStatusText = vbCrLf & "Toggle help display" & vbCrLf & _
                "Test or measurement display toggle" & vbCrLf & _
                "Grayscale or RGB gamma toggle" & vbCrLf & _
                "Measure grayscale gamma" & vbCrLf & _
                "Measure red, green, blue gamma"
        
        m_FontRect.Left = 70
        m_FontRect.Top = 20
        m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
        m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
        
        m_oStatusFont.End
        
    Else
        'build up a status string
        If g_d3dCaps.Caps2 And D3DCAPS2_FULLSCREENGAMMA = D3DCAPS2_FULLSCREENGAMMA Then
            'we can gamma ramp in full screen
            m_sStatusText = "SetGammaRamp support.  "
        Else
            m_sStatusText = ""
        End If
        m_sStatusText = m_sStatusText & "Press F1 for help." & vbCrLf
        
        'display gamma value
        If mnuSingleGamma.Checked = True Then
            m_sStatusText = m_sStatusText & "Single Gamma = " & _
                    format$(Gamma(m_Gamma(G_GRAY)), "0.0000") & _
                    " (" & m_Gamma(G_GRAY) & ")"
            
        Else
            m_sStatusText = m_sStatusText & "RGB Gamma = <" & _
                    format$(Gamma(m_Gamma(G_RED)), "0.00") & "," & _
                    format$(Gamma(m_Gamma(G_GREEN)), "0.00") & "," & _
                    format$(Gamma(m_Gamma(G_BLUE)), "0.00") & _
                    "> (" & m_Gamma(G_RED) & _
                    "," & m_Gamma(G_GREEN) & _
                    "," & m_Gamma(G_BLUE) & ")"
        End If
        
        m_FontRect.Left = 0
        m_FontRect.Top = m_lBufHeight - 40
        
        'draw text
        m_oStatusFont.Begin
        m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
        m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
        m_oStatusFont.End
        
        'display either the test or measurement graphics
        If mnuTest.Checked = True Then
            RenderGammaTest
        Else
            RenderMeasureGamma
        End If
    End If
    
    'end scene
    g_dev.EndScene
    
    Render = True
Exit Function

errOut:
    Render = False
End Function

'-----------------------------------------------------------------------------
' Name: RenderGammaTest()
' Desc: Test the currently set gamma values by rendering a series
'       of 5 vertical bars at 0%, 25%, 50%, 75% and 100% full
'       intensity.  Underneath the bars is drawn an interpolated
'       quad from 0% to 100%.  With proper gamma correction, they
'       will appear equal intensity at the center of the constant
'       intensity bars.
'
'          +--+-----+-----+-----+--+
'          |  |     |     |     |  |
'          |  |     |     |     |  |
'          | 0| 25  | 50  | 75  |100
'          |  |     |     |     |  |
'          +--+-----+-----+-----+--+
'          |                       |
'          |                       |
'          |        Gradient       |
'          |                       |
'          +-----------------------+
'-----------------------------------------------------------------------------
Public Sub RenderGammaTest()
    Dim Quarters(5) As Long
    Dim left_quarter As Long
    Dim right_quarter As Long
    Dim one_eighth As Long
    Dim three_eighths As Long
    Dim five_eighths As Long
    Dim seven_eighths As Long
    Dim half_height As Long
    Dim lTop As Long
    Dim lLeft As Long
    Dim lRight As Long
    
    '5 solid colors that will be used to render vertical bars
    Quarters(0) = D3DCOLORAUX.D3DColorXRGB(0, 0, 0)
    Quarters(1) = TestColors(25)
    Quarters(2) = TestColors(50)
    Quarters(3) = TestColors(75)
    Quarters(4) = D3DCOLORAUX.D3DColorXRGB(255, 255, 255)
    
    'get locations to render bars and text
    left_quarter = (m_Left + m_Center) / 2
    right_quarter = (m_Center + m_Right) / 2
    one_eighth = (m_Left + left_quarter) / 2
    three_eighths = (left_quarter + m_Center) / 2
    five_eighths = (m_Center + right_quarter) / 2
    seven_eighths = (right_quarter + m_Right) / 2
    
    If m_Top > 20 Then
        lTop = m_Top - 20
    Else
        lTop = 2
    End If
    
    If m_Left > 10 Then
        lLeft = m_Left - 10
    Else
        lLeft = 2
    End If
    
    If m_Right > 20 Then
        lRight = m_Right - 20
    Else
        lRight = 2
    End If
    
    'draw text headings
    m_oStatusFont.Begin
    
    m_sStatusText = "0%"
    m_FontRect.Left = lLeft
    m_FontRect.Top = lTop
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
    
    m_sStatusText = "25%"
    m_FontRect.Left = left_quarter - 20
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
    
    m_sStatusText = "50%"
    m_FontRect.Left = m_Center - 20
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
    
    m_sStatusText = "75%"
    m_FontRect.Left = right_quarter - 20
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
    
    m_sStatusText = "100%"
    m_FontRect.Left = lRight
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
    
    m_oStatusFont.End
    
    'create stripe vertices
    half_height = (m_Top + m_Bottom) / 2
    
    m_Stripes(0) = MakeVertex(m_Left, m_Top, Quarters(0))
    m_Stripes(1) = MakeVertex(one_eighth, m_Top, Quarters(0))
    m_Stripes(2) = MakeVertex(one_eighth, m_Top, Quarters(1))
    m_Stripes(3) = MakeVertex(three_eighths, m_Top, Quarters(1))
    m_Stripes(4) = MakeVertex(three_eighths, m_Top, Quarters(2))
    m_Stripes(5) = MakeVertex(five_eighths, m_Top, Quarters(2))
    m_Stripes(6) = MakeVertex(five_eighths, m_Top, Quarters(3))
    m_Stripes(7) = MakeVertex(seven_eighths, m_Top, Quarters(3))
    m_Stripes(8) = MakeVertex(seven_eighths, m_Top, Quarters(4))
    m_Stripes(9) = MakeVertex(m_Right, m_Top, Quarters(4))
    m_Stripes(10) = MakeVertex(m_Left, half_height, Quarters(0))
    m_Stripes(11) = MakeVertex(one_eighth, half_height, Quarters(0))
    m_Stripes(12) = MakeVertex(one_eighth, half_height, Quarters(1))
    m_Stripes(13) = MakeVertex(three_eighths, half_height, Quarters(1))
    m_Stripes(14) = MakeVertex(three_eighths, half_height, Quarters(2))
    m_Stripes(15) = MakeVertex(five_eighths, half_height, Quarters(2))
    m_Stripes(16) = MakeVertex(five_eighths, half_height, Quarters(3))
    m_Stripes(17) = MakeVertex(seven_eighths, half_height, Quarters(3))
    m_Stripes(18) = MakeVertex(seven_eighths, half_height, Quarters(4))
    m_Stripes(19) = MakeVertex(m_Right, half_height, Quarters(4))
    m_Stripes(20) = MakeVertex(m_Left, m_Bottom, Quarters(0))
    m_Stripes(21) = MakeVertex(m_Right, m_Bottom, Quarters(4))
    
    'create indices for bars
    m_Indices(0) = 0
    m_Indices(1) = 1
    m_Indices(2) = 10
    m_Indices(3) = 1
    m_Indices(4) = 11
    m_Indices(5) = 10
    
    m_Indices(6) = 2
    m_Indices(7) = 3
    m_Indices(8) = 12
    m_Indices(9) = 3
    m_Indices(10) = 13
    m_Indices(11) = 12
    
    m_Indices(12) = 4
    m_Indices(13) = 5
    m_Indices(14) = 14
    m_Indices(15) = 5
    m_Indices(16) = 15
    m_Indices(17) = 14
    
    m_Indices(18) = 6
    m_Indices(19) = 7
    m_Indices(20) = 16
    m_Indices(21) = 7
    m_Indices(22) = 17
    m_Indices(23) = 16
    
    m_Indices(24) = 8
    m_Indices(25) = 9
    m_Indices(26) = 18
    m_Indices(27) = 9
    m_Indices(28) = 19
    m_Indices(29) = 18
    
    'the interpolated ramp
    m_Indices(30) = 10
    m_Indices(31) = 19
    m_Indices(32) = 20
    m_Indices(33) = 19
    m_Indices(34) = 21
    m_Indices(35) = 20
    
    'render indexed primitives
    g_dev.SetVertexShader VERTEX_FVF
    g_dev.DrawIndexedPrimitiveUP D3DPT_TRIANGLELIST, 0, 22, 12, _
            m_Indices(0), D3DFMT_INDEX16, m_Stripes(0), Len(m_Stripes(0))
End Sub

'-----------------------------------------------------------------------------
' Name: RenderMeasureGamma()
' Desc: Render the graphics used to measure the gamma of the monitor.
'-----------------------------------------------------------------------------
Public Sub RenderMeasureGamma()
    Dim corrected As Integer
    Dim solid_fg As Long
    Dim line_fg As Long
    Dim half_width As Long
    Dim half_height As Long
    Dim NumLines As Long
    Dim i As Long
    
    'show instructions
    m_sStatusText = "Adjust the left and right sides to the same intensity." & vbCrLf & _
            "Controls: Up/Down, Page Up/Down, Home, End"
    
    m_FontRect.Left = 0
    m_FontRect.Top = 0
    
    m_oStatusFont.Begin
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_CALCRECT, 0&
    m_oStatusFont.DrawTextW m_sStatusText, -1&, m_FontRect, DT_NOCLIP Or DT_LEFT, GammaColorEx(m_ColorText)
    m_oStatusFont.End
    
    'determine foreground colors for gamma graphics
    corrected = m_Gamma(m_eWhichGamma)
    
    'determine foreground colors for gamma graphics
    Select Case m_eWhichGamma
        Case G_GRAY
            line_fg = D3DCOLORAUX.D3DColorXRGB(255, 255, 255)
            solid_fg = D3DCOLORAUX.D3DColorXRGB(corrected, corrected, corrected)
            
        Case G_RED
            line_fg = D3DCOLORAUX.D3DColorXRGB(255, 0, 0)
            solid_fg = D3DCOLORAUX.D3DColorXRGB(corrected, 0, 0)
            
        Case G_GREEN
            line_fg = D3DCOLORAUX.D3DColorXRGB(0, 255, 0)
            solid_fg = D3DCOLORAUX.D3DColorXRGB(0, corrected, 0)
            
        Case G_BLUE
            line_fg = D3DCOLORAUX.D3DColorXRGB(0, 0, 255)
            solid_fg = D3DCOLORAUX.D3DColorXRGB(0, 0, corrected)
            
        Case Else
            'invalid flag
            Exit Sub
    End Select
    
    'first the alternating black and white lines
    NumLines = (m_Bottom - m_Top + 1) / 2
    
    ReDim m_Vertices(NumLines * 2)
    
    For i = 0 To NumLines - 1
        m_Vertices(i * 2 + 0) = MakeVertex(m_Left, m_Top + i * 2, line_fg)
        m_Vertices(i * 2 + 1) = MakeVertex(m_Center, m_Top + i * 2, line_fg)
    Next i
    
    g_dev.SetVertexShader VERTEX_FVF
    g_dev.DrawPrimitiveUP D3DPT_LINELIST, NumLines, m_Vertices(0), Len(m_Vertices(0))
    
    For i = 0 To NumLines - 2
        m_Vertices(i * 2 + 0) = MakeVertex(m_Left, m_Top + i * 2 + 1, 0&)
        m_Vertices(i * 2 + 1) = MakeVertex(m_Center, m_Top + i * 2 + 1, 0&)
    Next i
    
    g_dev.DrawPrimitiveUP D3DPT_LINELIST, NumLines, m_Vertices(0), Len(m_Vertices(0))
    
    'now the adjacent solid area
    half_width = (m_Right + m_Center) / 2
    half_height = (m_Top + m_Bottom) / 2
    
    m_Solid(0) = MakeVertex(half_width, half_height, solid_fg) 'triangle fan center
    m_Solid(1) = MakeVertex(m_Center, m_Top, solid_fg)
    m_Solid(2) = MakeVertex(m_Right, m_Top, solid_fg)
    m_Solid(3) = MakeVertex(m_Right, m_Bottom, solid_fg)
    m_Solid(4) = MakeVertex(m_Center, m_Bottom, solid_fg)
    m_Solid(5) = MakeVertex(m_Center, m_Top, solid_fg)         '4 corners
    
    g_dev.DrawPrimitiveUP D3DPT_TRIANGLEFAN, 4, m_Solid(0), Len(m_Solid(0))
End Sub

'-----------------------------------------------------------------------------
' Name: TestColors()
' Desc: Given an percentage of white in [0,100], returns the
'       appropriate color to use to render test geometry at
'       the current gamma value.
'-----------------------------------------------------------------------------
Private Function TestColors(ByVal lPercent As Long) As Long
    Dim recip_gamma As Single
    Dim recip_gray As Single
    Dim recip_red As Single
    Dim recip_green As Single
    Dim recip_blue As Single
    Dim HoldColor As Long
    Dim Linear As Integer
    Dim corrected As Integer
    Dim Red As Integer
    Dim Green As Integer
    Dim Blue As Integer
    
    'if we can't correct with SetGammaRamp, we have to hand correct ourselves
    If g_Adapters(g_lCurrentAdapter).bWindowed = True Or _
                (g_d3dCaps.Caps2 And D3DCAPS2_FULLSCREENGAMMA) <> D3DCAPS2_FULLSCREENGAMMA Then
        If m_eWhichGamma = G_GRAY Then
            'do RGB with one gamma value
            recip_gamma = Log(m_Gamma(G_GRAY) / 255!) / Log(0.5!)
            corrected = RampValue(lPercent * 255 / 100, recip_gamma, 255)
            HoldColor = D3DCOLORAUX.D3DColorXRGB(corrected, corrected, corrected)
            
        Else
            'do RGB with one gamma each for red, green, blue
            recip_red = Log(m_Gamma(G_RED) / 255!) / Log(0.5!)
            recip_green = Log(m_Gamma(G_GREEN) / 255!) / Log(0.5!)
            recip_blue = Log(m_Gamma(G_BLUE) / 255!) / Log(0.5!)
            Red = RampValue(lPercent * 255 / 100, recip_red, 255)
            Green = RampValue(lPercent * 255 / 100, recip_green, 255)
            Blue = RampValue(lPercent * 255 / 100, recip_blue, 255)
            HoldColor = D3DCOLORAUX.D3DColorXRGB(Red, Green, Blue)
        End If
        
    Else
        'SetGammaRamp gamma corrects, give back RGB linear colors
        Linear = lPercent * 255 / 100
        HoldColor = D3DCOLORAUX.D3DColorXRGB(Linear, Linear, Linear)
    End If
    
    'return result
    TestColors = HoldColor
End Function

'-----------------------------------------------------------------------------
' Name: InitDeviceObjects()
' Desc: This creates all device-dependant managed objects, such as managed
'       textures and managed vertex buffers.
'-----------------------------------------------------------------------------
Public Sub InitDeviceObjects()
    '
End Sub

'-----------------------------------------------------------------------------
' Name: RestoreDeviceObjects()
' Desc: Restore device-memory objects and state after a device is created or
'       resized.
'-----------------------------------------------------------------------------
Public Sub RestoreDeviceObjects()
    Dim DispMode As D3DDISPLAYMODE
    
    'get current display settings
    g_dev.GetDisplayMode DispMode
    
    'cache size of frame buffer
    If g_d3dpp.Windowed Then
        m_lBufWidth = g_lWindowWidth
        m_lBufHeight = g_lWindowHeight
    Else
        m_lBufWidth = DispMode.width
        m_lBufHeight = DispMode.height
    End If
    
    'cache display format for status text
    m_DispFormat = DispMode.format
    
    'initialize status text object
    CreateFonts
    
    'set render states that we need
    SetStates
    
    'compute some layout geometry:
    'the alternating lines and solid area are maximally drawn within
    'an inner rectangle of the client area.  The inner rectangle is
    'inside the client area with a uniform margin on all sides.  Try
    'to keep the margin until the window becomes so small that the
    'margin is larger than 20% of the window dimension, then yield
    'margin space to the gamma correction graphics.  There is no
    'margin between the polyline and solid areas, they should abut
    'with no gap.
    Const MARGIN = 50
    
    m_Top = MARGIN
    m_Bottom = m_lBufHeight - MARGIN
    
    If m_lBufHeight < 3 * MARGIN Then
        m_Top = 0
        m_Bottom = m_lBufHeight
        
    ElseIf m_lBufHeight < 5 * MARGIN Then
        m_Top = (m_lBufHeight - 3 * MARGIN) / 2
        m_Bottom = m_lBufHeight - m_Top
    End If
    
    'this makes sure there is always an odd number of lines
    If (m_Bottom - m_Top) Mod 2 = 0 Then
        m_Bottom = m_Bottom - 1
    End If
    
    m_Center = m_lBufWidth / 2
    m_Left = MARGIN
    m_Right = m_lBufWidth - MARGIN
    
    If m_lBufWidth < 3 * MARGIN Then
        m_Left = 0
        m_Right = m_lBufWidth
        
    ElseIf m_lBufWidth < 5 * MARGIN Then
        m_Left = m_Center - 3 * MARGIN / 2
        m_Right = m_Center + 3 * MARGIN / 2
    End If
    
    'update and set gamma ramp
    UpdateRamp
    SetRamp
End Sub

'-----------------------------------------------------------------------------
' Name: UpdateRamp()
' Desc: Updates the current gamma ramp into m_Ramp based on the
'       currently selected gamma type.
'-----------------------------------------------------------------------------
Public Sub UpdateRamp()
    Dim recip_gray As Single
    Dim recip_red As Single
    Dim recip_green As Single
    Dim recip_blue As Single
    Dim i As Long
    
    If (g_d3dCaps.Caps2 And D3DCAPS2_FULLSCREENGAMMA) = D3DCAPS2_FULLSCREENGAMMA And _
            mnuTest.Checked = True Then
        If mnuSingleGamma.Checked = True Then
            'compute 1/gamma
            recip_gray = RecipGamma(m_Gamma(G_GRAY))
            
            'compute i*(1/gamma) for all i and scale to range
            For i = 0 To 255
                m_Ramp.Red(i) = LongToInt(RampValue(i, recip_gray))
                m_Ramp.Green(i) = m_Ramp.Red(i)
                m_Ramp.Blue(i) = m_Ramp.Red(i)
            Next i
            
        Else
            recip_red = RecipGamma(m_Gamma(G_RED))
            recip_green = RecipGamma(m_Gamma(G_GREEN))
            recip_blue = RecipGamma(m_Gamma(G_BLUE))
            
            For i = 0 To 255
                m_Ramp.Red(i) = LongToInt(RampValue(i, recip_red))
                m_Ramp.Green(i) = LongToInt(RampValue(i, recip_green))
                m_Ramp.Blue(i) = LongToInt(RampValue(i, recip_blue))
            Next i
        End If
        
    Else
        For i = 0 To 255
            m_Ramp.Red(i) = LongToInt((65535 * i) / 255)
            m_Ramp.Green(i) = m_Ramp.Red(i)
            m_Ramp.Blue(i) = m_Ramp.Red(i)
        Next i
    End If
End Sub

'-----------------------------------------------------------------------------
' Name: SetRamp()
' Desc: Set the gamma ramp on the device. This is called when
'       the device is being initialized and when we're toggling
'       the test/measure mode.
'-----------------------------------------------------------------------------
Public Sub SetRamp()
    If g_Adapters(g_lCurrentAdapter).bWindowed = False And _
                (g_d3dCaps.Caps2 And D3DCAPS2_FULLSCREENGAMMA) = D3DCAPS2_FULLSCREENGAMMA Then
        g_dev.SetGammaRamp D3DSGR_NO_CALIBRATION, m_Ramp
    End If
End Sub

'-----------------------------------------------------------------------------
' Name: IncGamma()
' Desc: Increase (or decrease) the currently selected gamma value,
'       clamping between the HOME_GAMMA and END_GAMMA values.
'-----------------------------------------------------------------------------
Public Sub IncGamma(ByVal Delta As Long)
    m_Gamma(m_eWhichGamma) = m_Gamma(m_eWhichGamma) + Delta
    
    If m_Gamma(m_eWhichGamma) < HOME_GAMMA Then m_Gamma(m_eWhichGamma) = HOME_GAMMA
    If m_Gamma(m_eWhichGamma) > END_GAMMA Then m_Gamma(m_eWhichGamma) = END_GAMMA
    
    UpdateRamp
End Sub

'-----------------------------------------------------------------------------
' Name: InvalidateDeviceObjects()
' Desc: Called when the device-dependant objects are about to be lost.
'-----------------------------------------------------------------------------
Public Sub InvalidateDeviceObjects()
    Set m_oStatusFont = Nothing
End Sub

'-----------------------------------------------------------------------------
' Name: DeleteDeviceObjects()
' Desc: Called when the app is exiting, or the device is being changed,
'       this function deletes any device dependent objects.
'-----------------------------------------------------------------------------
Public Sub DeleteDeviceObjects()
    'device objects are no longer initialized
    m_bIsInit = False
End Sub

'-----------------------------------------------------------------------------
' Name: VerifyDevice()
' Desc: Called during device intialization, this code checks the device
'       for some minimum set of capabilities.
'-----------------------------------------------------------------------------
Public Function VerifyDevice(ByVal usageflags As Long, ByVal format As CONST_D3DFORMAT) As Boolean
    VerifyDevice = True
End Function

'-----------------------------------------------------------------------------
' Name: mnuChangeDevice_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuChangeDevice_Click()
    Form_KeyDown vbKeyF2, 0
End Sub

'-----------------------------------------------------------------------------
' Name: mnuExit_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuExit_Click()
    Unload Me
End Sub

'-----------------------------------------------------------------------------
' Name: mnuGoStop_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuGoStop_Click()
    If m_bIsRunning = True Then
        DXUtil_Timer TIMER_STOP
        m_bIsRunning = False
    Else
        DXUtil_Timer TIMER_start
        m_bIsRunning = True
    End If
End Sub

'-----------------------------------------------------------------------------
' Name: mnuSingleStep_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuSingleStep_Click()
    If m_bIsRunning = True Then
        DXUtil_Timer TIMER_STOP
        m_bIsRunning = False
    End If
    
    'manually advance time
    'm_fTime = m_fTime + 0.1
End Sub

'-----------------------------------------------------------------------------
' Name: mnuHelpDisplay_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuHelpDisplay_Click()
    mnuHelpDisplay.Checked = Not mnuHelpDisplay.Checked
End Sub

'-----------------------------------------------------------------------------
' Name: mnuTest_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuTest_Click()
    mnuTest.Checked = Not mnuTest.Checked
    
    'update and set gamma ramp
    UpdateRamp
    SetRamp
End Sub

'-----------------------------------------------------------------------------
' Name: mnuGray_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuGray_Click()
    ClearCheckmarks
    mnuGray.Checked = True
    m_eWhichGamma = G_GRAY
End Sub

'-----------------------------------------------------------------------------
' Name: mnuRed_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuRed_Click()
    ClearCheckmarks
    mnuRed.Checked = True
    m_eWhichGamma = G_RED
End Sub

'-----------------------------------------------------------------------------
' Name: mnuGreen_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuGreen_Click()
    ClearCheckmarks
    mnuGreen.Checked = True
    m_eWhichGamma = G_GREEN
End Sub

'-----------------------------------------------------------------------------
' Name: mnuBlue_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuBlue_Click()
    ClearCheckmarks
    mnuBlue.Checked = True
    m_eWhichGamma = G_BLUE
End Sub

'-----------------------------------------------------------------------------
' Name: mnuSingleGamma_Click()
' Desc:
'-----------------------------------------------------------------------------
Private Sub mnuSingleGamma_Click()
    mnuSingleGamma.Checked = Not mnuSingleGamma.Checked
    
    'update and set gamma ramp
    UpdateRamp
    SetRamp
End Sub

'-----------------------------------------------------------------------------
' Name: ClearCheckmarks()
' Desc:
'-----------------------------------------------------------------------------
Private Sub ClearCheckmarks()
    mnuGray.Checked = False
    mnuRed.Checked = False
    mnuGreen.Checked = False
    mnuBlue.Checked = False
End Sub

